"use strict"; // ...-5 | -3 | -2 | -1 | -1 | 0 | 1 | 1 | 2 | 3 | 5 | 8 | 13...  класична послідовність
              // ...-5 | -4 | -3 | -2 | -1 | 0 | 1 | 2 | 3 | 4 | 5 | 6 | 7...   порядковий номер
              //                            f0 |f1 |f2... и т.д

//**********************************************************************************************************************

//  0  |  1  |  1  |  2  |  3  |  5  |  8  |  13  |  21...  класична послідовність
// -4  | -3  | -2  | -1  |  0  |  1  |  2  |  3   |  4...   порядковий номер, рахуємо від f0
//    ...f3  |  f2 |  f1 |  f0 |  f1 |  f2... и т.д
//    ⇐  n < 0  ⇒          |      ⇐  n > 0  ⇒
//  негативна область       |     позитивна область

let   f0 = +prompt("Перше число послідовності?"),
      f1 = +prompt("Друге число послідовності?"),
      n = +prompt("порядковый № числа?"),
      f2 = 0
const k = n,
      mass = (t,k) => alert(`число n:${k} => ${t}`)

if (n > 0 && f0 > f1 || n < 0 && f0 < f1  ){
   let w = f0        // В позитивній області повинно бути f0 > f1. Якщо користувач не ввів реверс n < 0 // це помилка
       f0 = f1       // В негативній області повинно бути f0 < f1. Тут також якщо не ввів n > 0 // це теж помилка
       f1 = w         //  тому в цих випадках, якщо значення введено неправильно, перевертаємо
}                      //

//**********************************************************************************************************************

function calc(){
    switch (true) {
        case(k === 0): mass(f0,k); console.log('k === 0')
            break
        case (k === 1 || k === -1): mass(f1,k); console.log('k === -1 или 1')
            break
        case(k > 0 && f0 >= 0 && f1 > 0): pos(f0,f1,f2);console.log('позитивна область')
            break
        case(k < 0 && f0 < 0 && f1 < 0): neg(f0,f1,f2);console.log('негативна область')
            break
        case (k < 0 && f0 > 0 && f1 >= 0):reversePos(f0,f1,f2); console.log('позитивна у зворотному напрямку')
            break
        case (k > 0 && f0 < 0 && f1 <= 0):reverseNeg(f0,f1,f2); console.log('негативна у зворотному напрямку')
            break
    }
}

calc()

function pos(f0,f1,f2){            //позитивна область
    console.log("--------pos--------")
    console.log(`f0 = ${f0}, f1 = ${f1}, f2 = ${f2}`)
    console.log("--------pos--------")
    for (; n > 1; n--) {
        f2 = f0 + f1
        f0 = f1
        f1 = f2
        console.log(`pos() n = ${f2}`)
    }
    return mass(f2,k)
}

function neg(f0,f1,f2) {          //негативна область
    console.log("--------neg--------")
    console.log(`f0 = ${f0}, f1 = ${f1}, f2 = ${f2}`)
    console.log("--------neg--------")
    for (; n < -1 ; n++) {
        f2 = f0 + f1
        f0 = f1
        f1 = f2
        console.log(`neg() n = ${f2}`)
    }
    return mass(f2,k)
}

//якщо користувач ввів негативный n та позитивні значення f0,f1, або позитивний n та негативні значення f0,f1,
//ведемо рахунок у зворотному напрямку та передбачаємо перехід в область з протилежним знаком

function reversePos(f0,f1,f2){   //позитивна у зворотному напрямку
    console.log("-----reversePos----")
    console.log(`f0 = ${f0}, f1 = ${f1}, f2 = ${f2}`)
    console.log("-----reversePos----")
    for (; n < -1; n++){
        f2 = f0 - f1
        if (f2 <= 0)break
        f0 = f1
        f1 = f2
        console.log(`rP() n = ${f2}`)
    }
    if(f2 < 0){                           //перевіряємо чи потрапляємо при перетині кордону областей у нуль
        f0 = f0 *-1
        f1 = f1 *-1
        n = n + 1
    } else if (f2 === 0) {
       f0 = f1
       f1 = f0 * -1
    }
    neg(f0,f1,f2)                            //переведемо рахунок у негативну область
}

function reverseNeg(f0,f1,f2) {          //негативна область у зворотному напрямку
    console.log("-----reverseNeg----")
    console.log(`f0 = ${f0}, f1 = ${f1}, f2 = ${f2}`)
    console.log("-----reverseNeg----")
    for (; n > 1; n--) {
        f2 = f0 - f1
        if (f2 >= 0) break
            f0 = f1
            f1 = f2
        console.log(`rN() n = ${f2}`)
    }
    if(f2 > 0){
        f0 = f0 * -1
        f1 = f1 * -1
        n = n - 1
    }else if (f2 === 0){
           f0 = f1
           f1 = f0 * -1
    }
    pos(f0,f1,f2)                        //переведемо рахунок у позитивну область
}





